﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BioLab.Biometrics.Face;
using BioLab.ImageProcessing;
using BioLab.Common;
using System.ComponentModel;
using BioLab.Classification.Supervised;
using BioLab.Math.Geometry;
using BioLab.Math.LinearAlgebra;
using BioLab.Biometrics.GUI;

namespace FaceRecognition
{
    //[BioLab.GUI.Forms.CustomAlgorithmPreviewOutput(typeof(BioLab.Biometrics.GUI.ClassifierFaceDetectorOutputViewer))]
    public class MyClassifierFaceDetector : FaceDetector
    {
        [AlgorithmParameter]
        public FaceFeatureExtractor FeatureExtractor { get; set; }

        [AlgorithmParameter]
        public Classifier Classifier { get; set; }

        [AlgorithmParameter]
        [DefaultValue(defaultMinimumWindowSize)]
        public int MinimumWindowSize { get; set; }

        [AlgorithmParameter]
        [DefaultValue(defaultMaximumScaleFactor)]
        public double MaximumScaleFactor { get; set; }

        [AlgorithmParameter]
        [DefaultValue(defaultScaleIncrementStep)]
        public double ScaleIncrementStep { get; set; }

        [AlgorithmOutput]
        public ICollection<FaceLocationCandidate> IntermediateCandidates { get; set; }

        private const int defaultMinimumWindowSize = 50;
        private const double defaultMaximumScaleFactor = 2.0;
        private const double defaultScaleIncrementStep = 0.5;

        public MyClassifierFaceDetector()
        {
        }

        public MyClassifierFaceDetector(FaceFeatureExtractor featureExtractor, Classifier classifier)
        {
            FeatureExtractor = featureExtractor;
            Classifier = classifier;
            InitProperties();
        }

        private void InitProperties()
        {
            MinimumWindowSize = defaultMinimumWindowSize;
            MaximumScaleFactor = defaultMaximumScaleFactor;
            ScaleIncrementStep = defaultScaleIncrementStep;
        }

        public MyClassifierFaceDetector(FaceFeatureExtractor featureExtractor, Classifier classifier, Image<byte> inputImage)
            : base(inputImage)
        {
            FeatureExtractor = featureExtractor;
            Classifier = classifier;
            InitProperties();
        }

        public override void Run()
        {
          throw new NotImplementedException();
        }
        
        private List<FaceLocationCandidate> PostProcessing(List<FaceLocationCandidate> detFaces, double percOverlap)
        {
          throw new NotImplementedException();
        }

        private int Overlap(FaceLocationCandidate face1, FaceLocationCandidate face2)
        {
          throw new NotImplementedException();
        }

    }
}
